CREATE PROCEDURE [dbo].[CHECK_TRANSFER_POSTING_FROM_IPPCS_TO_ICS_NEW]
(
	@ARRIVAL_PLAN_FROM AS VARCHAR(MAX),
	@ARRIVAL_PLAN_TO AS VARCHAR(MAX)
	
)
AS
BEGIN
DECLARE @TSQL1 varchar(8000),
		@TSQL2 varchar(8000), 
		@RowStart INT,
		@RowEnd INT,
		@MatDocNo varchar(10);

IF object_id('tempdb..#ICSTP') IS NOT NULL DROP TABLE #ICSTP
IF object_id('tempdb..#OUTPUT_PART') IS NOT NULL DROP TABLE #OUTPUT_PART
IF object_id('tempdb..#OUTPUT_MANIFEST') IS NOT NULL DROP TABLE #OUTPUT_MANIFEST

CREATE TABLE #ICSTP
(
	MAT_DOC_YEAR	VARCHAR(4),
	MAT_DOC_NO	VARCHAR(10),
	ORI_MAT_NO	VARCHAR(23),
	REFF_NO VARCHAR(16),
	ITEM_QUANTITY	INT,
)

SELECT  @TSQL1 = 'select * from openquery(IPPCS_TO_ICS,''
					select 
						d.mat_doc_year,
						d.mat_doc_no, 
						d.ORI_MAT_NO as PART_NUMBER,
						h.REFF_NO as MANIFEST_NO, 
						d.item_quantity as ICS_QUANTITY
					from tb_r_mat_doc_h h 
						join tb_r_mat_doc_d d
							on h.MAT_DOC_NO = d.Mat_Doc_No 
							   and h.mat_doc_year = d.mat_doc_year
					where h. POSTING_DT > to_date( ''''' +@ARRIVAL_PLAN_FROM + ''''' ,''''YYYYMMDD'''')  
						  and  h.POSTING_DT <= to_date(''''' +@ARRIVAL_PLAN_TO + ''''',''''YYYYMMDD'''') 
						  and h.transaction_type = ''''TP''''
						  and h.system_source = ''''IPPCS''''
						  and d.direction_of_movement = ''''+''''
					order by d.mat_doc_no
				  '')'

insert into #ICSTP
EXEC (@TSQL1)

--SELECT * FROM (
	SELECT
		--Y.mat_doc_year  ,
		--Y.mat_doc_no, 
		X.MANIFEST_NO,
		X.SUPPLIER_CD,
		X.SUPPLIER_PLANT,
		X.DOCK_CD,
		--X.mat_doc_no, 
		--Y.mat_no as PART_NUMBER,
		X.PART_NO as PART_NUMBER,
		--Y.REFF_NO as MANIFEST_NO, 
		X.TOTAL_IPCCS_TP,
		Y.ITEM_QUANTITY as ICS_QUANTITY,
		CASE WHEN ISNULL(X.TOTAL_IPCCS_TP, 0) <> ISNULL(Y.ITEM_QUANTITY, 0) THEN 1 ELSE 0 END as RESULT
	INTO #OUTPUT_PART
	FROM 
	(
		SELECT 
			a.MANIFEST_NO, 
			P.PART_NO , 
			a.SUPPLIER_CD,
			a.SUPPLIER_PLANT,
			a.DOCK_CD,
			SUM(P.ORDER_QTY) AS TOTAL_IPCCS_TP
		FROM TB_R_DAILY_ORDER_MANIFEST A 
			INNER JOIN TB_R_DAILY_ORDER_PART P
				ON A.MANIFEST_NO = P.MANIFEST_NO
		WHERE
			--a.MANIFEST_RECEIVE_FLAG in ('3','2','5','4')
			A.DROP_STATUS_DT >  CONVERT(varchar(11),(CONVERT(DATETIME, @ARRIVAL_PLAN_FROM, 112)),106)
			AND A.DROP_STATUS_DT <= CONVERT(varchar(11),(CONVERT(DATETIME, @ARRIVAL_PLAN_TO, 112)),106)
			AND a.TOTAL_QTY> 0
			AND P.ORDER_QTY > 0
			AND a.SUPPLIER_CD LIKE '807%'
			AND a.MANIFEST_NO IS NOT NULL
			AND (A.CANCEL_FLAG = 0 OR A.CANCEL_FLAG is null)
		GROUP BY a.MANIFEST_NO, 
				 P.PART_NO, 
				 P.ORDER_QTY, 
				 a.SUPPLIER_CD, 
				 a.SUPPLIER_PLANT, 
				 a.DOCK_CD
	) AS X 
	LEFT JOIN  #ICSTP Y 
		ON X.MANIFEST_NO = Y.REFF_NO  
		   AND X.PART_NO = Y.ORI_MAT_NO 
		   --AND X.MAT_DOC_NO = Y.MAT_DOC_NO
	--order by X.MANIFEST_NO asc
--) as t --where isnull (t.ICS_QUANTITY,0) <> t.TOTAL_IPCCS_TP

SELECT 
	MANIFEST_NO,
	SUM(RESULT) as RESULT
INTO #OUTPUT_MANIFEST
FROM #OUTPUT_PART
GROUP BY MANIFEST_NO

UPDATE M 
SET
	M.MANIFEST_RECEIVE_FLAG = CASE WHEN RESULT > 0 THEN M.MANIFEST_RECEIVE_FLAG ELSE '4' END,
	M.IN_PROGRESS = CASE WHEN RESULT > 0 THEN M.IN_PROGRESS ELSE '2' END
FROM #OUTPUT_MANIFEST P
	JOIN TB_R_DAILY_ORDER_MANIFEST M
		ON M.MANIFEST_NO = P.MANIFEST_NO
END

